import { localize } from '../../../../../nls.js';
import { MenuId } from '../../../../../platform/actions/common/actions.js';
import { RawContextKey } from '../../../../../platform/contextkey/common/contextkey.js';
const MENU_TERMINAL_CHAT_INPUT = MenuId.for('terminalChatInput');
const MENU_TERMINAL_CHAT_WIDGET = MenuId.for('terminalChatWidget');
const MENU_TERMINAL_CHAT_WIDGET_STATUS = MenuId.for('terminalChatWidget.status');
MenuId.for('terminalChatWidget.toolbar');
var TerminalChatContextKeys;
( ((function(TerminalChatContextKeys) {
    TerminalChatContextKeys.focused = ( (new RawContextKey(
        "terminalChatFocus" ,
        false,
        ( localize(10685, "Whether the chat view is focused."))
    )));
    TerminalChatContextKeys.visible = ( (new RawContextKey(
        "terminalChatVisible" ,
        false,
        ( localize(10686, "Whether the chat view is visible."))
    )));
    TerminalChatContextKeys.requestActive = ( (new RawContextKey(
        "terminalChatActiveRequest" ,
        false,
        ( localize(10687, "Whether there is an active chat request."))
    )));
    TerminalChatContextKeys.inputHasText = ( (new RawContextKey(
        "terminalChatInputHasText" ,
        false,
        ( localize(10688, "Whether the chat input has text."))
    )));
    TerminalChatContextKeys.responseContainsCodeBlock = ( (new RawContextKey(
        "terminalChatResponseContainsCodeBlock" ,
        false,
        ( localize(10689, "Whether the chat response contains a code block."))
    )));
    TerminalChatContextKeys.responseContainsMultipleCodeBlocks = ( (new RawContextKey(
        "terminalChatResponseContainsMultipleCodeBlocks" ,
        false,
        ( localize(10690, "Whether the chat response contains multiple code blocks."))
    )));
    TerminalChatContextKeys.hasChatAgent = ( (new RawContextKey(
        "terminalChatAgentRegistered" ,
        false,
        ( localize(10691, "Whether a chat agent is registered for the terminal location."))
    )));
})(TerminalChatContextKeys || (TerminalChatContextKeys = {}))));
export { MENU_TERMINAL_CHAT_INPUT, MENU_TERMINAL_CHAT_WIDGET, MENU_TERMINAL_CHAT_WIDGET_STATUS, TerminalChatContextKeys };
